      subroutine makegrid_1d

c     make table for opacity in 1-D envelope.
c     created 02/11/00 by barbara whitney

      implicit none

      include 'nums.txt'
      include 'arrays.txt'
     
      real iopb,rnri,dri,rei,c,b,rtau,dr,rad,rho
      integer iflag,i

      print*,' '
      print*, 'making opacity grid...'

c     iopb determines grid spacing; r(i)=c*i**iopb
      iopb=1./opb
      write(6,*) 'iopb',iopb

      rnri=nri
      dri=(rmaxe-rmin)/(rnri-1.0)**opb
      write(6,*) 'dri',dri
      do i=1,nri
         rei=i
         ri(i)=rmin+dri*(rei-1.)**opb
      enddo

c     set one of the grid points to rmine, for higher accuracy
	if (rmine.gt.rmin) then
	  call locate(ri,nri,rmine,i)
	    ri(i+1)=rmine
      endif

c     r-squared array, to avoid taking square roots later on
      rminsq=rmin*rmin
	do i=1,nri
	  risq(i)=ri(i)*ri(i)
	enddo

c     density goes as rho**(rhoexp)
c     calculate constant of proportionality so envelope tau=taumax
      if (rhoexp.ne.-1.0) then
         c=1.+rhoexp
         b=taumax*c/(rmaxe**c-rmine**c)
      else
         b=taumax/(alog(rmaxe)-alog(rmine))
      endif

      rtau=0.
      do i=1,nri-1
         dr=(ri(i+1)-ri(i))
c        since density is described by an analytic equation easy
c        to integrate, set optical depth of cell equal to 
c        integral(rho*dr)
         if (ri(i).ge.rmine) then
            if (rhoexp.ne.-1.0) then
               opaci(i)=b/c*(ri(i+1)**c-ri(i)**c)/dr
            else
               opaci(i)=b*(alog(ri(i+1))-alog(ri(i)))/dr
            endif   
            rtau=rtau+opaci(i)*dr
	      tauint(i+1)=rtau
         else
            opaci(i)=0.
         endif      
      end do

      print*, 'optical depth through spherical envelope = ',rtau
      print*, 'should equal taumax ',taumax

      print*,'done with opacity grid '
      print*, ' '

      return
      end	
