      program sphere
c**********************************************************************
c        program follows photons through a 1-d spherical atmosphere.        
c**********************************************************************

      implicit none

      real tau,albedo,xtot,ytot,ztot,xold,yold,zold,rstar
      real ran2
      real sint,cost,sinp,cosp,phi,fractx
     1  ,ux,uy,x,y,aflux,energy,cosa
      integer i,l,aflag,nphotons,exitflag,ix,iy

      include 'arrays.txt'
      include 'random.txt'
      include 'nums.txt'

c ... load parameters. Those not passed as arguments are in common blocks.
      namelist/spher/nphotons,i1,rstar,rmine,rmaxe,taumax,rhoexp,albedo
     1 ,limb
      open(5,file='sphere.par',status='unknown')
      read(5,spher)
      close(5)

      rmin=rstar

c     initialize arrays and constants
      call iarray
      call makegrid_1d
	if (limb.eq.1) call table

c     initialize and define variables
      fractx=2.*rmaxe/float(nx)
      energy=0.

c******************** do loop over each stellar photon ****************

      do i=1,nphotons

	 if (mod(i,10000).eq.0) then
	     print *,i,' stellar photons completed'
	 endif
c       if (i.eq.37753) then
c	     print *,i,' stellar photons completed'
c         continue
c       endif

         exitflag=0
	 call newphoton(sint,cost,cosa,sinp,cosp,phi,xtot,ytot,ztot)
       ux=sint*cosp
       uy=sint*sinp
       ii=1    !photon's place in grid starts here
c      update JHK moments
       jplus(ii)=jplus(ii)+1./cosa
       hplus(ii)=hplus(ii)+1.
       kplus(ii)=kplus(ii)+cosa


c        photons scatters until it exits
 10      continue
	   aflag=0
	   xold=xtot
           yold=ytot
           zold=ztot
           tau=-alog(ran2(i1))
          call tauint_1d(tau,xold,yold,zold,cost,ux,uy,xtot,ytot,ztot,
     1      aflux,aflag,exitflag,i)
           if (aflag.eq.1) go to 30
           if (exitflag.eq.1) go to 20
c           call moments(xold,yold,zold,xtot,ytot,ztot,cost)
           if(ran2(i1).lt.albedo) then
             call isoscatt(sint,cost,sinp,cosp,phi)
             ux=sint*cosp
             uy=sint*sinp
	   else
             aflux=aflux+1
	     go to 30
	   end if
         go to 10

 20      continue
         energy=energy+1.        
         x = yold*cosp-xold*sinp
         y = zold*sint-yold*cost*sinp-xold*cost*cosp
         ix=int((x+rmaxe)/fractx)+1
         iy=int((y+rmaxe)/fractx)+1
         if (ix.le.nx.and.iy.le.nx.and.ix.gt.0.and.iy.gt.0.) then
            image(ix,iy)=image(ix,iy)+1.
         else
            print*,'error in making image '
         endif

 30   end do
      
c     ********************************************************

c     put results into intensities.
      call output(nphotons,aflux,energy)

      end
