c     **********************************************************

      subroutine tauint_1d(tau,xold,yold,zold,cost,ux,uy,xp,yp,zp,aflux,
     1 aflag,exitflag,iphot)

      implicit none

      include 'arrays.txt'
	include 'nums.txt'
      
      real tsum,opac,dtau,ds,xp,yp,zp,xold,yold,zold,cost,ux,uy
     1 ,aflux,tau,rtot,rsq,costii
      integer iphot,iRoffset,aflag,exitflag,iinew

      tsum=0.d0

      xp=xold
      yp=yold
      zp=zold

10    continue
      call find_wall_1D(ds,iRoffset, risq(ii),risq(ii+1),
     &     ux,uy,cost,xp,yp,zp)

      if (ds.le.1.e-5) then
        ds=1.e-5
	  continue
	endif

      opac=opaci(ii)        
      dtau=opac*ds              !optical depth to edge of cell
c     test to see if tau is exceeded before cell wall reached.
c     if so, calculate distance where this happens.  
      if ((tsum+dtau).gt.tau) then
         ds=(tau-tsum)/opac
         xp=xp+ds*ux
         yp=yp+ds*uy
         zp=zp+ds*cost
c        we are done with optical depth integration
         go to 300
      endif

      ii=ii+iRoffset

      xp=xp+ds*ux*1.001
      yp=yp+ds*uy*1.001
      zp=zp+ds*cost*1.001
      tsum=tsum+dtau

      if (ii.eq.nri) then
c        photon exits system
         exitflag=1
         costii=(xp*ux+yp*uy+zp*cost)/rmaxe
c        may need to normalize by area too...
	  if (costii.gt.0.) then
	    jplus(ii)=jplus(ii)+1./costii
	    hplus(ii)=hplus(ii)+1.
	    kplus(ii)=kplus(ii)+costii
	   else
	      print*, 'oops, costii should be > 0 ',costii
	      continue
	endif
         go to 300
      end if


c     Due roundoff error, when we update position to the cell
c     boundary, we sometimes undershoot and are in the wrong
c     cell.  So we need to locate cell position, but use 
c     radius-squared array to avoid taking a square root.
      rsq=xp*xp+yp*yp+zp*zp
      call locate(risq,nri,rsq,iinew)
c     iinew should equal ii unless there's roundoff error

c     testing
      if (iinew.eq.ii) then
c      calculate moments
        if (ii.ge.1) then
        rtot=sqrt(rsq)
        costii=(xp*ux+yp*uy+zp*cost)/rtot
c        may need to normalize by area too...
	  if (costii.gt.0.) then
	    jplus(ii)=jplus(ii)+1./costii
	    hplus(ii)=hplus(ii)+1.
	    kplus(ii)=kplus(ii)+costii
	  else
	    jminus(ii+1)=jminus(ii+1)-1./costii
	    hminus(ii+1)=hminus(ii+1)-1.
	    kminus(ii+1)=kminus(ii+1)-costii
        endif
	  endif
      else 
c       numerical precision error, should update next time around
        if (iinew.eq.0) then
	   continue
	   count=count+1
	   endif
	  ii=iinew
	endif

	if (rsq.lt.rminsq*1.0001) then
c	if you want to absorb photon at star, do this.
         aflux=aflux+1.d0
         costii=(xp*ux+yp*uy+zp*cost)/rmin
	    jminus(1)=jminus(1)-1./costii
	    hminus(1)=hminus(1)-1.
	    kminus(1)=kminus(1)-costii
         aflag=1
         go to 300
c        or, if you want photon to scatter at stellar surface, do this
c15       xp=xp*1.001
c	   yp=yp*1.001
c	   zp=zp*1.001
c	   rsq=(xp**2+yp**2+zp**2)
c           if (rsq.lt.rminsq) go to 15
c	have to write a new photon routine that emits from this place
c	on the surface
      endif

      go to 10

300   return
      end
